#ifndef _DRIVER_CONF_H
 #define _DRIVER_CONF_H

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <stdlib.h>
#include <stdio.h>
#include <regex.h>
#include <string.h>


typedef struct command_s {
	int type;
	int int1;
	int int2;
	char * char1;
	char * char2;
} command_t;

typedef struct driver_s {
	char * name;
	int major;
	char * interface;

	int (* do_1) (char * name, int major);
	int (* do_2) (char * name, int major);
	int (* do_3) (char * name, int major);
	
	command_t fault_cmds[10];
	int nr_fault_cmds;

	command_t recover_cmds[10];
	int nr_recover_cmds;

	command_t last_cmds[10];
	int nr_last_cmds;
} driver_t;

extern char ** regexp(char * pattern, char * str);
extern int load_driver_conf(driver_t * d);
extern int do_driver_recover(driver_t * d);

#define NOOKS_MODULE_PATH "/etc/nooks/modules/"

#define ON_FAULT		1
#define ON_RECOVER		2
#define ON_LAST			3

#define IS_POL(X)	( (X) & 0x1000 )
#define IS_CMD(X)	(~( (X) & 0x1000 ))

#define POL_RECOVER 		0x1001
#define POL_RECOVER_N 		0x1010
#define POL_RECOVER_N_M 	0x1011
#define POL_DO_NOT_RECOVER 	0x1000

#define CMD_REPLACE 		0x0001
#define CMD_EXECUTE 		0x0010
#define CMD_MAIL 		0x0011

#define PERROR(X) printf("nooks-agent: " X " in "__FUNCTION__ "()\n") 
#define PINFO(X) printf("nooks-agent: " X "\n") 

#include "stats.h"
#include "execute.h"

#endif
