#include "stats.h"

int writestats(char *d_name, const char *fmt, ...)
{

	struct timeval timestamp;
	va_list args;

	static char buffer[1024];
	FILE *fd;

	gettimeofday(&timestamp, NULL);

	sprintf(buffer, NOOKS_MODULE_PATH "%s.stats", d_name);
	fd = fopen(buffer, "a");

	if (fd == NULL) {
		writelog("Can't open file \"%s\".\n", buffer);
		return -1;
	}

	fprintf(fd, "%010ld:%06ld ", timestamp.tv_sec, timestamp.tv_usec);

	va_start(args, fmt);

	printf(fmt, args);
	fprintf(fd, fmt, args);

	va_end(args);

	//  fsync(flog);
	fclose(fd);
	return 0;
}

int is_recover(char *str)
{

	char *p = str + 18;
	if (strncmp(p, "Recover", 7))
		return 0;
	return 1;
}

int get_times(char *d_name)
{

	static char buffer[1024];
	FILE *fd;
	int n = 0;

	sprintf(buffer, NOOKS_MODULE_PATH "%s.stats", d_name);
	fd = fopen(buffer, "r");
	if (fd == NULL) {
		writelog("Can't open file \"%s\".\n", buffer);
		return -1;
	}

	while (fgets(buffer, 1024, fd)) {
		printf("--%s", buffer);
		n += is_recover(buffer);
	}

	fclose(fd);

	return n;
}

int get_times_in_minutes(char *d_name, int mn)
{

	static char buffer[1024];
	FILE *fd;
	char **rm;
	struct timeval timestamp;
	unsigned long tmp;
	unsigned long tlim;
	int n = 0;

	gettimeofday(&timestamp, NULL);
	tlim = timestamp.tv_sec - mn * 60;

	sprintf(buffer, NOOKS_MODULE_PATH "%s.stats", d_name);
	fd = fopen(buffer, "r");
	if (fd == NULL) {
		writelog("Can't open file \"%s\".\n", buffer);
		return -1;
	}


	while (fgets(buffer, 1024, fd)) {
		rm = regexp("([[:digit:]]+):[[:digit:]]+ Recover\n",
			    buffer);
		if (rm != NULL) {
			tmp = atoi(rm[0]);

			if (tmp >= tlim)
				n++;

			free(rm[0]);
			free(rm);
		}

	}

	fclose(fd);

	return n;
}
